/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.datamaps.widgets;

import java.awt.Component;
import java.awt.Dimension;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.ListCellRenderer;
import org.apache.log4j.Logger;
import org.visnow.vn.datamaps.ColorMap;
import org.visnow.vn.datamaps.colormap1d.DefaultColorMap1D;
import org.visnow.vn.datamaps.colormap2d.ColorMap2D;
import org.visnow.vn.datamaps.utils.Orientation;

/**
 * @author Michał Łyczek (lyczek@icm.edu.pl)
 * University of Warsaw, Interdisciplinary Centre
 * for Mathematical and Computational Modelling
 */
public class ColorMapCellRenderer extends JPanel implements ListCellRenderer
{
    private static final Logger LOGGER = Logger.getLogger(ColorMapCellRenderer.class);
    
    /**
     * Creates new form ColorMapCellRenderer
     */
    public ColorMapCellRenderer()
    {
        initComponents();
        this.setPreferredSize(new Dimension(getWidth(), 36));
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        colorMapPreview1 = new org.visnow.vn.datamaps.widgets.ColorMapPreview();
        jLabel1 = new javax.swing.JLabel();

        setPreferredSize(new java.awt.Dimension(80, 50));

        colorMapPreview1.setMaximumSize(null);
        colorMapPreview1.setMinimumSize(null);
        colorMapPreview1.setName("colorMapPreview1"); // NOI18N
        colorMapPreview1.setPreferredSize(new java.awt.Dimension(32, 32));

        javax.swing.GroupLayout colorMapPreview1Layout = new javax.swing.GroupLayout(colorMapPreview1);
        colorMapPreview1.setLayout(colorMapPreview1Layout);
        colorMapPreview1Layout.setHorizontalGroup(
                colorMapPreview1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGap(0, 28, Short.MAX_VALUE)
                );
        colorMapPreview1Layout.setVerticalGroup(
                colorMapPreview1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGap(0, 28, Short.MAX_VALUE)
                );

        jLabel1.setFont(new java.awt.Font("Dialog", 0, 10)); // NOI18N
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel1.setText("jLabel1");
        jLabel1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jLabel1.setMaximumSize(null);
        jLabel1.setMinimumSize(null);
        jLabel1.setName("jLabel1"); // NOI18N
        jLabel1.setPreferredSize(null);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
                layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(layout.createSequentialGroup()
                                .addGap(2, 2, 2)
                                .addComponent(colorMapPreview1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(6, 6, 6)
                                .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE))
                );
        layout.setVerticalGroup(
                layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(layout.createSequentialGroup()
                                .addGap(2, 2, 2)
                                .addComponent(colorMapPreview1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGroup(layout.createSequentialGroup()
                                .addGap(2, 2, 2)
                                .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                );
    }// </editor-fold>//GEN-END:initComponents
    
    @Override
    public Component getListCellRendererComponent(
        JList list,
        Object value,
        int index,
        boolean isSelected,
        boolean cellHasFocus)
    {        
        setBackground((isSelected) ? list.getSelectionBackground() : list.getBackground());
        if (value == null || !(value instanceof ColorMap) || ((ColorMap) value).getName() == null) {
            return this;
        }
        jLabel1.setText(((ColorMap) value).getName());
        jLabel1.setForeground((isSelected) ? list.getSelectionForeground() : list.getForeground());
        if (value instanceof DefaultColorMap1D) {
            if (((DefaultColorMap1D) value).isBuildin()) {
                jLabel1.setText("* " + ((ColorMap) value).getName());
            }
            colorMapPreview1.setPreferredSize(new Dimension(96, 16));
            colorMapPreview1.setOrientation(Orientation.HORIZONTAL);
            setPreferredSize(new Dimension(80, 21));
        } else if (value instanceof ColorMap2D) {
            colorMapPreview1.setPreferredSize(new Dimension(32, 32));
            setPreferredSize(new Dimension(80, 37));
        }

        colorMapPreview1.setColorMap((ColorMap) value);

        jLabel1.setEnabled(isEnabled());
        colorMapPreview1.setEnabled(isEnabled());

        return this;
    }

    @Override
    public void setEnabled(boolean enabled)
    {
        super.setEnabled(enabled); //To change body of generated methods, choose Tools | Templates.
    }

    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private org.visnow.vn.datamaps.widgets.ColorMapPreview colorMapPreview1;
    private javax.swing.JLabel jLabel1;
    // End of variables declaration//GEN-END:variables
}
